
<script setup>
import * as yup from 'yup';
import { Form, Field } from 'vee-validate'
import { ref } from 'vue'
import api from '@/api/api'

const inputOptions = ref({ placeholder: '' })
const loading = ref(false)
const info = ref({
    first_name: '',
    last_name: '',
    text: '',
    phone: '',
    email: '',
})
const snackbar = ref(false)
const snackbarClass = ref('')
const snackbarText = ref('')
const validationRequired = ref('را وارد کنید')
const schema = yup.object({
    first_name: yup.string().required(`نام ${validationRequired.value}`),
    last_name: yup.string().required(`نام خانوادگی ${validationRequired.value}`),
    text: yup.string().required(`توضیحات ${validationRequired.value}`),
    phone: yup.string().trim().required(`تلفن همراه ${validationRequired.value}`),
    email: yup.string().email('لطفا پست الکترونیکی را صحیح وارد کنید').required(` پست الکترونیکی ${validationRequired.value}`),
});

const onSubmit = (values, { resetForm }) => {
    loading.value = true
    info.value.phone = info.value.phone.replace(/\s/g, '')
    api.post(`contact-us`, info.value).then(res => {
        snackbar.value = true
        snackbarClass.value = 'green-accent-2'
        snackbarText.value = 'پیام شما با موفقیت ارسال شد'
        resetForm();
        loading.value = false
    }).catch(err => {
        loading.value = false
        snackbar.value = true
        snackbarClass.value = 'deep-orange-accent-2'
        snackbarText.value = 'متاسفانه مشکلی رخ داده است. لطفا دوباره سعی کنید.'
    })
}
</script>

<template>
    <v-snackbar v-model="snackbar" :color="snackbarClass" location="top" :timeout="5000">
        {{ snackbarText }}
        <template v-slot:actions>
            <v-btn color="white" variant="text" @click="snackbar = false">
                <BootstrapIcon name="x-circle"></BootstrapIcon>
            </v-btn>
        </template>
    </v-snackbar>
    <Form as="v-form" :validation-schema="schema" @submit="onSubmit" class="px-md-16 px-0 mx-lg-16 mx-0">
        <v-row>
            <v-col cols="md-6" sm="6">
                <Field name="first_name" v-model="info.first_name" v-slot="{ field, errors }">
                    <v-text-field v-model="info.first_name" v-bind="field" density="compact" label="نام" variant="outlined"
                        :error-messages="errors"></v-text-field>
                </Field>
            </v-col>
            <v-col cols="md-6" sm="6">
                <Field name="last_name" v-model="info.last_name" v-slot="{ field, errors }">
                    <v-text-field v-model="info.last_name" v-bind="field" density="compact" label="نام خانوادگی"
                        variant="outlined" :error-messages="errors"></v-text-field>
                </Field>
            </v-col>
            <v-col cols="md-6" sm="6">
                <Field name="email" v-model="info.email" v-slot="{ field, errors }">
                    <v-text-field v-model="info.email" v-bind="field" density="compact" label="پست الکترونیکی"
                        variant="outlined" :error-messages="errors"></v-text-field>
                </Field>
            </v-col>
            <v-col cols="md-6" sm="6">
                <Field name="phone" v-model="info.phone" v-slot="{ field, errors }">
                    <vue-tel-input styleClasses="custom-tel-input" defaultCountry="ir" v-bind="field"
                        :inputOptions="inputOptions" dir="ltr" v-model="info.phone"></vue-tel-input>
                    <div class="invalid-feedback">
                        {{ errors[0] }}
                    </div>
                </Field>
            </v-col>
            <v-col cols="12">
                <Field name="text" v-model="info.text" v-slot="{ field, errors }">
                    <v-textarea v-model="info.text" v-bind="field" label="پیام" variant="outlined"
                        :error-messages="errors"></v-textarea>
                </Field>
            </v-col>
        </v-row>
        <v-btn :loading="loading" :disabled="loading" class="mt-3" type="submit" color="#1A237E" size="large"> ارسال
            پیام</v-btn>
    </Form>
</template>


<style lang="scss" scoped>
.invalid-feedback {
    color: rgb(var(--v-theme-error));
    font-size: 12px;
    padding: 6px 16px 0
}
</style>